local AddonName, GGL = ...
local Templates = GGL.Templates

local Set, SetHelper = Templates:Register("Set")

-- lua

-- wow

local SET_ID_LIST = GGL.SET_ID_LIST
-- ##################
-- local
-- ##################

-- ##################
-- static
-- ##################
local Static = {}
Templates.Set = Static

-- ##################
-- template
-- ##################
function Set:Constructor(setKey)
    self:LoadSet(setKey)
end

function Set:LoadSet(setKey)
    local db = GGL.db.Config.Sets[SET_ID_LIST.Set]
    self.setKey = setKey
    if db and db[setKey] then
        local pass, db = GGL:Deserialize(db[setKey].setting)
        self:SetFilterDB(db)
    else
        self:SetFilterDB()
    end
end

function Set:ReloadSet()
    if self.setKey then
        self:LoadSet(self.setKey)
    end
end

function Set:SetFilterDB(db)
    self.db = db or {}
end


-- ##################
-- Helper
-- ##################
function Set:GetSet(setID, getSettings)
    local setKey = self.db[setID] or "Base"
    if getSettings and GGL.db.Config.Sets[setID][setKey] then
        return GGL.db.Config.Sets[setID][setKey].setting
    else
        return setKey
    end
end

function Set:GetItemFilter(getSettings)
    if SET_ID_LIST.Item then
        return self:GetSet(SET_ID_LIST.Item, getSettings)
    end
end

function Set:GetPriceSource(getSettings)
    if SET_ID_LIST.PriceSource then
        return self:GetSet(SET_ID_LIST.PriceSource, getSettings)
    end
end

function Set:GetZoneFilter(getSettings)
    if SET_ID_LIST.Zone then
        return self:GetSet(SET_ID_LIST.Zone, getSettings)
    end
end

function Set:GetInstanceFilter(getSettings)
    if SET_ID_LIST.Instance then
        return self:GetSet(SET_ID_LIST.Instance, getSettings)
    end
end

function Set:GetLootSourceFilter(getSettings)
    if SET_ID_LIST.LootSource then
        return self:GetSet(SET_ID_LIST.LootSource, getSettings)
    end
end